import { UseStore } from 'idb-keyval';
import { EncodeCore, EncodeCoreConfig } from './encode-core.mjs';

declare class CacheCore<CacheDataType, EncodeDataType extends any[]> extends EncodeCore<EncodeDataType> {
    protected _cacheConfig: CacheCoreConfig;
    protected readonly _cacheStore: UseStore | undefined;
    constructor(_cacheConfig: CacheCoreConfig);
    _getCache(cacheKey: string): Promise<TypeCacheRecord<CacheDataType> | undefined>;
    _setCache(cacheKey: string, value: TypeCacheRecord<CacheDataType>): Promise<void>;
    deleteCache(cacheKey: string): Promise<void>;
    clearCache(): Promise<void>;
    protected _isCacheExpired(cache: TypeCacheRecord<CacheDataType> | undefined): boolean;
}
type TypeCacheRecord<T> = {
    data: T;
    updatedAt: number;
};
type CacheCoreConfig = {
    enableCache?: boolean;
    cacheExpiry?: number;
    cacheId?: string;
} & EncodeCoreConfig<any[]>;

export { CacheCore, type CacheCoreConfig, type TypeCacheRecord };
